---
editLink: false
---

# v8 - Make Faker Handier

Our main goal in v8 is to make Faker more lightweight and more flexible.

## v8.0 - Module Re-Shuffling

Finish the module shuffling.

- Remove locale switching support
- Move String and Number methods into own modules
- Rename Name module to Person
- Rename Address module to Location
- Check modules and methods regarding their name and location
- Try to eliminate circular dependencies in modules
- Standardize function parameters and defaults
- Rewrite image module / providers

[v8.0 Tasks](https://github.com/faker-js/faker/milestone/10)

## v8.1 - Split Faker Class

Split the Faker class into smaller units so you don't have ship an entire locale if you only generate some strings and numbers.

[v8.1 Tasks](https://github.com/faker-js/faker/milestone/11)

## v8.x - Tree-Shakeable Module-Functions

Refactor modules to be tree shakeable.
Potentially allowing individual Faker methods to be called by themselves.

[v8.x Tasks](https://github.com/faker-js/faker/milestone/12)
